macroScript WeldSelectedFloater
category:"Bluesummers' Tools" 
tooltip:"Opens the Weld Selected Texture Verts Floater"
ButtonText: "Weld Selected..."
(	
	--A script by Alex Bluesummers
	rollout WeldSelectedVerts "Weld Selected"
	(
		-- The actual rollout will be similar to the edit poly version.
		
		--fn createCustomHandlers =
		--fn destroyCustomHandlers = deleteAllCustomHandlers id:#WLDVERTS
		
		spinner Threshold "Weld Threshold:  " \
			range:[0,1E+5,1] fieldwidth:36 scale:.01
			
		group "Number of Vertices"
		(
			-- This group holds some data for the user.
			label Before 	"Before:  " across:4
			label NumBefore ""
			
			label After 	"After:  " 	
			label NumAfter 	""
		)
		button Apply 	"Apply" across:3
		button Okay		"OK"
		button Cancel	"Cancel"
		
		-- A prop for my website.  If you really hate it, you can remove it.
		hyperlink label1 "Mr. Bluesummers 2008" \
			address:"http://www.mrbluesummers.com" align:#center
		
		-- What we're doing is applying the change, then undoing it if
		-- the user changes a variable, or cancels the operation.
		-- Clicking ok just applies it.  Dirty but simple.		
		fn WeldVerts =
		(			
			max undo
			NumBefore.caption = $.modifiers[#unwrap_uvw].NumberVertices() as string
			$.modifiers[#unwrap_uvw].unwrap.weldSelected()
			$.modifiers[#unwrap_uvw].unwrap.expandSelection()
			$.modifiers[#unwrap_uvw].unwrap.contractSelection()
			NumAfter.caption = $.modifiers[#unwrap_uvw].NumberVertices() as string
		)
		
		-- The buttons
		on Apply 	pressed do 	destroyDialog WeldSelectedVerts
		on Okay 	pressed do (WeldVerts(); 	destroyDialog WeldSelectedVerts)
		on Cancel	pressed do (max undo; 		destroyDialog WeldSelectedVerts)
		
		-- The spinner
		on Threshold changed value do
		(
			$.modifiers[#unwrap_uvw].unwrap.setWeldThreshold (Threshold.value / 20)
			WeldVerts()
		)
		
		-- On open, set the threshold and commit a change.
		-- This is a special case, so it's not quite the same as the function.
		on WeldSelectedVerts open do 
		(
			$.modifiers[#unwrap_uvw].unwrap.setWeldThreshold (Threshold.value / 20)
			NumBefore.caption = $.modifiers[#unwrap_uvw].NumberVertices() as string
			NumAfter.caption = $.modifiers[#unwrap_uvw].NumberVertices() as string
			$.modifiers[#unwrap_uvw].unwrap.weldSelected()
		)
	)
	
	-- Create the dialog.  Make it modal; it's easier that way.
	createdialog WeldSelectedVerts style:(#(#style_boarder, #style_toolwindow)) modal:true
)
--		--		--		--		--
--Load the menu		--		--
--		--		--		--		--
if menuMan.registerMenuContext 0x1c413679 do
(
	local ToolsMenuIndex, ToolsMenuItem
	local ToolsMenu, WeldVertTool, UVW_MenuBar
	
	-- Get the main menu bar
	UVW_MenuBar = MenuMan.getMenu 128 
	
	-- The above is not always true.  Let's check to make
	-- sure so we don't totally wreck the UI
	if UVW_MenuBar.getTitle() != "UVW Unwrap - Menu Bar"
	do throw "Critical Error: Your UI Could not be modified \
				because you have made changes to your .mnu \
				file."
	 
	-- The Get the tools index.  Should be 4th from the left.
	-- Double check the title to make sure.
	for i = 1 to UVW_MenuBar.numItems() do
		if (UVW_MenuBar.getItem i).getTitle() == "Tools" do
			ToolsMenuIndex = i
	 
	-- Get the menu item that holds the help menu
	ToolsMenuItem = UVW_MenuBar.getItem(ToolsMenuIndex)
	 
	-- Get the menu from the item
	ToolsMenu = ToolsMenuItem.getSubMenu()
	
	-- Create a menu item that calls the WeldTexvert Tool.
	WeldVertTool = (menuMan.createActionItem "WeldSelectedFloater" "Bluesummers' Tools")
	
	-- Add the action item to the end of the help menu.
	ToolsMenu.addItem WeldVertTool 7
	 
	-- redraw the menu bar with the new item
	MenuMan.updateMenuBar()
)